/* @flow */

"use strict";

var _interopRequireWildcard = require("babel-runtime/helpers/interop-require-wildcard")["default"];

exports.__esModule = true;

var _babylon = require("babylon");

var babylon = _interopRequireWildcard(_babylon);

/**
 * Parse `code` with normalized options, collecting tokens and comments.
 */

exports["default"] = function (code /*: string*/) {
  var opts /*: BabelParserOptions*/ = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

  return babylon.parse(code, {
    allowImportExportEverywhere: opts.looseModules,
    allowReturnOutsideFunction: opts.looseModules,
    strictMode: opts.strictMode,
    sourceType: opts.sourceType,
    plugins: opts.plugins || []
  });
};

module.exports = exports["default"];