/* @flow */

"use strict";

var _interopRequireWildcard = require("babel-runtime/helpers/interop-require-wildcard")["default"];

exports.__esModule = true;

var _babelTypes = require("babel-types");

var t = _interopRequireWildcard(_babelTypes);

/*:: import type { Scope } from "babel-traverse";*/

var visitor = {
  enter: function enter(path, state) {
    if (path.isThisExpression() || path.isReferencedIdentifier({ name: "arguments" })) {
      state.found = true;
      path.stop();
    }
  },

  Function: function Function(path) {
    path.skip();
  }
};

exports["default"] = function (node /*: Object*/, scope /*: Scope*/) {
  var container = t.functionExpression(null, [], node.body, node.generator, node.async);

  var callee = container;
  var args = [];

  var state = { found: false };
  scope.traverse(node, visitor, state);
  if (state.found) {
    callee = t.memberExpression(container, t.identifier("apply"));
    args = [t.thisExpression(), t.identifier("arguments")];
  }

  var call = t.callExpression(callee, args);
  if (node.generator) call = t.yieldExpression(call, true);

  return t.returnStatement(call);
};

module.exports = exports["default"];