"use strict";

var _interopRequireDefault = require("babel-runtime/helpers/interop-require-default")["default"];

var _interopRequireWildcard = require("babel-runtime/helpers/interop-require-wildcard")["default"];

exports.__esModule = true;

var _loose = require("./loose");

var _loose2 = _interopRequireDefault(_loose);

var _vanilla = require("./vanilla");

var _vanilla2 = _interopRequireDefault(_vanilla);

var _babelTypes = require("babel-types");

var t = _interopRequireWildcard(_babelTypes);

var _babelHelperFunctionName = require("babel-helper-function-name");

var visitor = {
  ClassDeclaration: function ClassDeclaration(node) {
    return t.variableDeclaration("var", [t.variableDeclarator(node.id, t.toExpression(node))]);
  },

  ClassExpression: function ClassExpression(path, file) {
    var inferred = _babelHelperFunctionName.bare(path);
    if (inferred) return inferred;

    if (file.isLoose("es6.classes")) {
      return new _loose2["default"](path, file).run();
    } else {
      return new _vanilla2["default"](path, file).run();
    }
  }
};
exports.visitor = visitor;